
ChiliProject - Bug # 342: Version custom fields are missing shared versions

Status: Open Priority: Normal
Author: Eric Davis Category: Custom Fields
Created: 2011-04-17 Assignee:
Updated: 2013-08-23 Due date:
Remote issue URL:
Affected version: 3.1.0
Description: When reviewing commit:d8fbdca76 I noticed that it doesn't look like shared versions are supported in the list. 

Need to confirm and fix this if they are not listed.

File: app/models/custom_field.rb#possible_values_options is scoped to @project@ and only checks the 
direct association (@project.versions@)

History
2011-05-29 06:18 pm - Eric Davis
- Target version deleted (2.0.0)

- (deleted custom field) set to unstable

Not a 2.0.0-RC blocker

2012-04-10 01:14 pm - Matthias Scholz
- Target version set to 3.2.0

This Bug still affects chiliproject version 3.1.

2012-04-18 11:09 am - Mischa The Evil
Remote issue URL: http://www.redmine.org/issues/8615

2012-05-14 02:55 pm - Matthias Scholz
- Status changed from Open to Ready for review

Using the code permitted by the link from Mischa fixes this Bug:

Editing file  app\models\custom_fields.rb:
@ 55      when 'version'
56         # CHANGES HERE (versions -> shared versions)
57          obj.project.shared_versions.sort.collect {|u| [u.to_s, u.id.to_s]} 
58        end
@

Tested on ChiliProject 3.1.0.d61ad0130

2012-06-05 03:47 pm - Felix Schäfer
Could someone have a look at the Redmine code and make a pull request out of it? Thanks.

2012-06-05 03:47 pm - Felix Schäfer
- Status changed from Ready for review to Open
- Assignee deleted (Eric Davis)

2012-06-09 05:43 pm - Holger Just
- Target version deleted (3.2.0)

- Affected version changed from unstable to 3.1.0

Pulling this out of version:3.2.0 as it was not ready on release day.

2013-07-08 01:54 pm - Daniel F.
- Target version set to 3.9.0

This bug also affects Version 3.8, see #1280 for further information and a suggested bugfix.

Could you please try to include a patch for 3.9?

2013-08-23 06:26 am - Arthur Lee
Matthias Scholz wrote:
> Using the code permitted by the link from Mischa fixes this Bug:
> 
> Editing file  app\models\custom_fields.rb:
> @ 55      when 'version'
> 56         # CHANGES HERE (versions -> shared versions)
> 57          obj.project.shared_versions.sort.collect {|u| [u.to_s, u.id.to_s]} 
> 58        end
> @
> 
> Tested on ChiliProject 3.1.0.d61ad0130
>

I would suggest changing line 57 to 
@  obj.project.shared_versions.sort.collect {|u| [u.project.identifier + ': ' + u.to_s, u.id.to_s]}
@

2013-08-23 07:54 pm - Mischa The Evil
Arthur Lee wrote:
> I would suggest changing line 57 to
> @obj.project.shared_versions.sort.collect {|u| [u.project.identifier + ': ' + u.to_s, u.id.to_s]}@

That is basically implementing what I describe in remote issue URL http://www.redmine.org/issues/9850. Though, you use: 
<pre>obj.project.shared_versions.sort.collect {|u| [u.project.identifier + ': ' + u.to_s, u.id.to_s]}</pre> while in http://www.redmine.org/issues/9850#note-7 
I used: <pre>obj.project.shared_versions.sort.collect {|u| ["#{u.project.to_s} - #{u.to_s}", u.id.to_s]}</pre>

So, besides the differences in syntax, we differ in what should be prepended to the version name:

|You|"@{project identifier}: @" before the "@{version name}@"|
|Me|"@{project name} - @" before the "@{version name}@"|
I think it is better to use the project name here instead of the project identifier (which makes the use of a space followed by a dash and a following 
space more clearly instead of a colon followed by a space) but YMMV ;)
